Index: Makefile.inc1
===================================================================
--- Makefile.inc1	(revision 249665)
+++ Makefile.inc1	(working copy)
@@ -91,6 +91,11 @@
 .if ${MK_OFED} != "no"
 SUBDIR+=contrib/ofed
 .endif
+.if defined(.PARSEDIR) # bsd.test.mk doesn't work with !bmake
+.if defined(TESTS_WITH_WORLD)
+SUBDIR+=tests
+.endif
+.endif
 #
 # We must do etc/ last for install/distribute to work.
 #
@@ -277,6 +282,13 @@
 		VERSION="${VERSION}" \
 		INSTALL="sh ${.CURDIR}/tools/install.sh" \
 		PATH=${TMPPATH}
+
+# make hierarchy
+HMAKE=		${MAKE} LOCAL_MTREE=${LOCAL_MTREE}
+.if defined(NO_ROOT)
+HMAKE+=		METALOG=${METALOG} -DNO_ROOT
+.endif
+
 .if ${MK_CDDL} == "no"
 WMAKEENV+=	NO_CTF=1
 .endif
@@ -378,6 +390,14 @@
 IMAKE_MTREE=	MTREE_CMD="nmtree ${MTREEFLAGS}"
 .endif
 
+.if defined(.PARSEDIR) # bsd.test.mk doesn't work with !bmake
+.if defined(TESTS_WITH_WORLD) && !defined(NO_TESTS)
+HMAKE+=		-DWITH_TESTS
+IMAKE+=		-DWITH_TESTS
+WMAKE+=		-DWITH_TESTS
+.endif
+.endif
+
 # kernel stage
 KMAKEENV=	${WMAKEENV}
 KMAKE=		${KMAKEENV} ${MAKE} ${.MAKEFLAGS} ${KERNEL_FLAGS} KERNEL=${INSTKERNNAME}
@@ -488,8 +508,9 @@
 	@echo ">>> stage 4.2: building libraries"
 	@echo "--------------------------------------------------------------"
 	${_+_}cd ${.CURDIR}; \
-	    ${WMAKE} -DNO_FSCHG -DWITHOUT_HTML -DWITHOUT_INFO -DNO_LINT \
-	    -DWITHOUT_MAN -DNO_PROFILE libraries
+	    ${WMAKE:N-DWITH_TESTS} \
+	    -DNO_FSCHG -DWITHOUT_HTML -DWITHOUT_INFO -DNO_LINT \
+	    -DWITHOUT_MAN -DNO_PROFILE -DNO_TESTS libraries
 _depend:
 	@echo
 	@echo "--------------------------------------------------------------"
@@ -1320,12 +1341,7 @@
 # hierarchy - ensure that all the needed directories are present
 #
 hierarchy hier:
-.if defined(NO_ROOT)
-	cd ${.CURDIR}/etc; ${MAKE} LOCAL_MTREE=${LOCAL_MTREE} \
-	    -DNO_ROOT METALOG=${METALOG} distrib-dirs
-.else
-	cd ${.CURDIR}/etc; ${MAKE} LOCAL_MTREE=${LOCAL_MTREE} distrib-dirs
-.endif
+	cd ${.CURDIR}/etc && ${HMAKE} distrib-dirs
 
 #
 # libraries - build all libraries, and install them under ${DESTDIR}.
